/*************************************************************************
*
* File: Main.js
*
* Description: 
* Script that controls the gadget functionality for the 
* Call of Duty: Black Ops Countdown Clock countdown clock
* 
* 
* Copyright (c) bonesnap.com  All rights reserved.
* 
* 
* THIS CODE AND INFORMATION ARE PROVIDED AS IS WITHOUT WARRANTY OF ANY
* KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
* PARTICULAR PURPOSE.
* 
************************************************************************/
 
// Member variables.
var oFlyoutDocument; 
var delay=100; 
var timerID;
BackColor = "transparent";
ForeColor = "white"; 
CountActive = true;
CountStepper = -1;
LeadingZero = true;
DisplayFormat = "%%D%% Days, %%H%%:%%M%%:%%S%%";
FinishMessage = "   IT IS HERE!!!!";
var SetTimeOutPeriod;
var TargetDate;
//hard code program value
var ClockName="Call of Duty: Black Ops Countdown Clock";
TargetDate = "11/09/2010";
// --------------------------------------------------------------------
// Initialize the gadget.
// --------------------------------------------------------------------
// Member variables.
var oFlyoutDocument; 

function Init()
{
    System.Gadget.background = "images/background.png";
    System.Gadget.Flyout.show=false;
   
    var oGadgetDocument = System.Gadget.document; 
    var eHide = oGadgetDocument.getElementById("Release");
    
     // Specify the flyout root.
     System.Gadget.Flyout.file = "gadget_flyout.html"; 
     System.Gadget.background = "images/backdrop.png";
     System.Gadget.Flyout.show=false;
     
    
    System.Gadget.settingsUI='gadget_settings.html';
    createRequest('http://www.bonesnap.com/gadgets/RSSGadgetInfo.rss');
    checkIt();
}

// --------------------------------------------------------------------
// Display the flyout associated with Cards
// --------------------------------------------------------------------
function showFlyout()
{

    var oGadgetDocument = System.Gadget.document; 
    System.Gadget.Flyout.show = true;            
}




// --------------------------------------------------------------------
// Body load of the flyout
// --------------------------------------------------------------------

function FlyOutLoad()
{
   var oGadgetDocument = System.Gadget.document; 
}

// --------------------------------------------------------------------
// Body load of the flyout
// --------------------------------------------------------------------

function GoHome()
{
    window.open('http://www.bonesnap.com','mywindow');
}
 
// --------------------------------------------------------------------
// Open Browser window.
// --------------------------------------------------------------------

     // --------------------------------------------------------------------
     // Open Browser window.
     // --------------------------------------------------------------------
     function goDeveloper()
     {
          // Specify the window.
          window.open('http://www.treyarch.com/','mywindow');
     }
     // --------------------------------------------------------------------
     // Open Browser window.
     // --------------------------------------------------------------------
     function goGameHome()
     {
          // Specify the window.
          window.open('www.callofduty.com','mywindow');
     }
     // --------------------------------------------------------------------
     // Open Browser window.
     // --------------------------------------------------------------------
     function getReleaseInfo()
     {
          // Specify the window.
          window.open('http://www.bonesnap.com/blog/2010/08/25/call-of-duty-black-ops/','mywindow');
     }
   // --------------------------------------------------------------------
   // Check for Make Request
   // --------------------------------------------------------------------
   
    function createRequest(urlstring) 
    { 
  
         xmlHttpObj = new XMLHttpRequest(); 
         xmlHttpObj.onreadystatechange = readyStateHandler; 
         xmlHttpObj.open('GET',urlstring,true); 
         xmlHttpObj.send(null);
    
   }
   
        
   // --------------------------------------------------------------------
   // Error Checker?
   // --------------------------------------------------------------------
           
        
      function readyStateHandler(event)
      {
        if (xmlHttpObj.readyState == 4 && xmlHttpObj.status == 200)
         { 
           updateDisplay();
  	    }
      }
        
 

   // --------------------------------------------------------------------
   // Update Display
   // --------------------------------------------------------------------
         
    
        function updateDisplay() 
        {
         var sourceDOM = xmlHttpObj.responseXML;
         var outputArea = document.getElementById('outputArea'); 
         var itemNodes = sourceDOM.getElementsByTagName('item');
         var itemReleaseDate;
         var itemTitle;
         var itemDate;
         var xcount=0;
	 var currentTime = new Date();
	 var month = currentTime.getMonth() + 1;
	 var day = currentTime.getDate();
	 var year = currentTime.getFullYear();
         var dated=month+"/"+day+"/"+year;
         var titlename;
         var tempdate;    
         var isit=false;     
        
         var outputArea = document.getElementById('outputArea'); 
       
          for (i=0; i<itemNodes.length; i++)
           {
             for (j=0; j<itemNodes[i].childNodes.length; j++) 
             {
              if (itemNodes[i].childNodes[j].nodeName == 'ReleaseDate') 
               {
               itemTitle=itemNodes[i].childNodes[j].firstChild.nodeValue;
	       tempdate="";
		tempdate=tempdate+itemTitle;	
	       }
               //write out saying
              
              
               if (itemNodes[i].childNodes[j].nodeName == 'title') 
	        {
	          itemTitle=itemNodes[i].childNodes[j].firstChild.nodeValue;
	      	  titlename="";
	          titlename=titlename+itemTitle;	
	        }


               if (itemNodes[i].childNodes[j].nodeName == 'ReleaseInfo') 
	        {
	          itemTitle=itemNodes[i].childNodes[j].firstChild.nodeValue;
	      	  itemReleaseDate="";
	          itemReleaseDate=itemReleaseDate+itemTitle;	
	        }


                if (ClockName==titlename)    
                {
                    TargetDate=tempdate;
               
                    var oGadgetDocument = System.Gadget.document; 
	            var eHide = oGadgetDocument.getElementById("Release");

          	    if (itemReleaseDate=="No") 
                    {
                     eHide.style.visibility = 'hidden';
                    }
                    else
                    {
                     eHide.style.visibility = 'visible';
                    }
     
                   
                   
                   
                }
                
    	     }
          }
            //now let's grab the new saying

        
     //write out saying
	//outputArea.innerHTML = "test"; 

          
}

       


// --------------------------------------------------------------------
// Count Down Clock
// --------------------------------------------------------------------
 


function calcage(secs, num1, num2) 
{
  s = ((Math.floor(secs/num1))%num2).toString();
  if (LeadingZero && s.length < 2)
    s = "0" + s;
  return "<b>" + s + "</b>";
}

function CountBack(secs) 
{
  if (secs < 0) {
    document.getElementById("cntdwn").innerHTML = FinishMessage;
    playSound();
    return;
  }
  DisplayStr = DisplayFormat.replace(/%%D%%/g, calcage(secs,86400,100000));
  DisplayStr = DisplayStr.replace(/%%H%%/g, calcage(secs,3600,24));
  DisplayStr = DisplayStr.replace(/%%M%%/g, calcage(secs,60,60));
  DisplayStr = DisplayStr.replace(/%%S%%/g, calcage(secs,1,60));

  document.getElementById("cntdwn").innerHTML = DisplayStr;
  if (CountActive)
    setTimeout("CountBack(" + (secs+CountStepper) + ")", SetTimeOutPeriod);
}

function putspan(backcolor, forecolor) 
{
 	        //now let's grab the new saying
 	       var outputArea = document.getElementById('outputArea'); 
 	        
   	     //write out saying
 		outputArea.innerHTML = "<span id='cntdwn' style='background-color:" + backcolor + "; color:" + forecolor + "'></span>"; 
         

 //document.write("<span id='cntdwn' style='background-color:" + backcolor + 
 //               "; color:" + forecolor + "'></span>");
}


function setTime()
{
if (typeof(BackColor)=="undefined")
  BackColor = "white";
if (typeof(ForeColor)=="undefined")
  ForeColor= "black";
if (typeof(TargetDate)=="undefined")
  TargetDate = "12/31/2020 5:00 AM";
if (typeof(DisplayFormat)=="undefined")
  DisplayFormat = "%%D%% Days, %%H%% Hours, %%M%% Minutes, %%S%% Seconds.";
if (typeof(CountActive)=="undefined")
  CountActive = true;
if (typeof(FinishMessage)=="undefined")
  FinishMessage = "";
if (typeof(CountStepper)!="number")
  CountStepper = -1;
if (typeof(LeadingZero)=="undefined")
  LeadingZero = true;


CountStepper = Math.ceil(CountStepper);
if (CountStepper == 0)
  CountActive = false;

SetTimeOutPeriod = (Math.abs(CountStepper)-1)*1000 + 990;
putspan(BackColor, ForeColor);
var dthen = new Date(TargetDate);
var dnow = new Date();

if(CountStepper>0)
  ddiff = new Date(dnow-dthen);
else
  ddiff = new Date(dthen-dnow);
gsecs = Math.floor(ddiff.valueOf()/1000);

CountBack(gsecs);
   
}
   
   
   
       
// --------------------------------------------------------------------
// Play Sound
// --------------------------------------------------------------------
    
function playSound()
{

          //Play the sound
    var results="sounds\\yeah.wav"; 
    System.Sound.playSound(results);
   
}   

// --------------------------------------------------------------------
// Kick off-
// I think we are processing the next function before the data is back
// from the xml call.
// set this function to call the right one once complete.
// --------------------------------------------------------------------
    
function checkIt()
{

  if (typeof(TargetDate)=="undefined")
  {
     setTimeout("checkIt()", 1000);
  }
   else
  {
  	setTime()
   }

   
}   
